Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/IOM/iom_nf90.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/IOM/iom_nf90.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/IOM/iom_nf90.F90	(revision 3938)
@@ -181,5 +181,5 @@
 
 
-   FUNCTION iom_nf90_varid ( kiomid, cdvar, kiv, kdimsz )  
+   FUNCTION iom_nf90_varid ( kiomid, cdvar, kiv, kdimsz, kndims )  
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION  iom_varid  ***
@@ -191,4 +191,5 @@
       INTEGER              , INTENT(in   )           ::   kiv   ! 
       INTEGER, DIMENSION(:), INTENT(  out), OPTIONAL ::   kdimsz   ! size of the dimensions
+      INTEGER,               INTENT(  out), OPTIONAL ::   kndims   ! size of the dimensions
       !
       INTEGER                        ::   iom_nf90_varid   ! iom variable Id
@@ -242,4 +243,5 @@
             ENDIF
          ENDIF
+         IF( PRESENT(kndims) )  kndims = iom_file(kiomid)%ndims(kiv)
       ELSE  
          iom_nf90_varid = -1   !   variable not found, return error code: -1
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3938)
@@ -362,5 +362,5 @@
 
 
-   SUBROUTINE mpp_lnk_3d( ptab, cd_type, psgn, cd_mpp, pval )
+   SUBROUTINE mpp_lnk_3d( ptab, cd_type, psgn, cd_mpp, pval, ldup )
       !!----------------------------------------------------------------------
       !!                  ***  routine mpp_lnk_3d  ***
@@ -390,4 +390,5 @@
       CHARACTER(len=3), OPTIONAL      , INTENT(in   ) ::   cd_mpp   ! fill the overlap area only 
       REAL(wp)        , OPTIONAL      , INTENT(in   ) ::   pval     ! background value (used at closed boundaries)
+      LOGICAL         , OPTIONAL      , INTENT(in   ) ::   ldup     ! duplicate value (used at closed boundaries)
       !!
       INTEGER  ::   ji, jj, jk, jl             ! dummy loop indices
@@ -427,4 +428,10 @@
             ptab( 1 ,:,:) = ptab(jpim1,:,:)
             ptab(jpi,:,:) = ptab(  2  ,:,:)
+         ELSEIF ( nperio == 0 .AND. PRESENT( ldup ) ) THEN
+            ptab(3,:,:) = ptab(2,:,:)
+            ptab(:,3,:) = ptab(:,2,:)
+            ptab(nlci-2,:,:) = ptab(nlci-1,:,:)
+            ptab(:,nlcj-2,:) = ptab(:,nlcj-1,:)
+           
          ELSE                                     !* closed
             IF( .NOT. cd_type == 'F' )   ptab(     1       :jpreci,:,:) = zland    ! south except F-point
@@ -559,5 +566,5 @@
 
 
-   SUBROUTINE mpp_lnk_2d( pt2d, cd_type, psgn, cd_mpp, pval )
+   SUBROUTINE mpp_lnk_2d( pt2d, cd_type, psgn, cd_mpp, pval, ldup )
       !!----------------------------------------------------------------------
       !!                  ***  routine mpp_lnk_2d  ***
@@ -585,4 +592,5 @@
       CHARACTER(len=3), OPTIONAL  , INTENT(in   ) ::   cd_mpp   ! fill the overlap area only 
       REAL(wp)        , OPTIONAL  , INTENT(in   ) ::   pval     ! background value (used at closed boundaries)
+      LOGICAL         , OPTIONAL  , INTENT(in   ) ::   ldup     ! duplicate value (used at closed boundaries)
       !!
       INTEGER  ::   ji, jj, jl   ! dummy loop indices
@@ -621,4 +629,9 @@
             pt2d( 1 ,:) = pt2d(jpim1,:)                                    ! west
             pt2d(jpi,:) = pt2d(  2  ,:)                                    ! east
+         ELSEIF ( nperio == 0 .AND. PRESENT( ldup ) ) THEN
+            pt2d(3,:) = pt2d(2,:)
+            pt2d(:,3) = pt2d(:,2)
+            pt2d(nlci-2,:) = pt2d(nlci-1,:)
+            pt2d(:,nlcj-2) = pt2d(:,nlcj-1)
          ELSE                                     ! closed
             IF( .NOT. cd_type == 'F' )   pt2d(     1       :jpreci,:) = zland    ! south except F-point
@@ -2011,4 +2024,10 @@
       CALL MPI_ALLREDUCE( kice, zwork, jpnij, mpi_integer, mpi_sum, mpi_comm_opa, ierr )
       ndim_rank_ice = SUM( zwork )          
+ 
+      !SF ! if there is no ice in the domain, return to the main program (clem modif)
+     !SF  IF ( ndim_rank_ice == 0 ) THEN
+      !SF    DEALLOCATE(kice, zwork)
+     !SF     RETURN
+     !SF  ENDIF
 
       ! Allocate the right size to nrank_north
@@ -2027,5 +2046,5 @@
       ! Create the world group
       CALL MPI_COMM_GROUP( mpi_comm_opa, ngrp_world, ierr )
-
+ 
       ! Create the ice group from the world group
       CALL MPI_GROUP_INCL( ngrp_world, ndim_rank_ice, nrank_ice, ngrp_ice, ierr )
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c3d.h90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c3d.h90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c3d.h90	(revision 3938)
@@ -35,5 +35,8 @@
       REAL(wp) ::   zd_max       ! maximum grid spacing over the global domain
       REAL(wp) ::   za00, zc, zd, zetmax, zefmax, zeumax, zevmax   ! local scalars
-      REAL(wp), POINTER, DIMENSION(:) :: zcoef   
+      REAL(wp), POINTER, DIMENSION(:)   :: zcoef   
+      INTEGER,  PARAMETER               :: zrim = 5  ! number of grid points over which diffusion is increased linearly
+      REAL(wp), PARAMETER               :: zinc_coef = 0.0 ! coef of diffusion increase  
+      INTEGER  ::   ii0, ii1, ij0, ij1   ! temporary integers
       !!----------------------------------------------------------------------
       !
@@ -88,17 +91,17 @@
             CALL ldf_dyn_c3d_orca( ld_print )
          ENDIF
-
-      ENDIF
-      
-      ! Control print
-      IF(lwp .AND. ld_print ) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) '         3D ahm1 array (k=1)'
-         CALL prihre( ahm1(:,:,1), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1.e-3, numout )
-         WRITE(numout,*)
-         WRITE(numout,*) '         3D ahm2 array (k=1)'
-         CALL prihre( ahm2(:,:,1), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1.e-3, numout )
-      ENDIF
-
+	 
+      	 ! Control print
+         IF(lwp .AND. ld_print ) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) '         3D ahm1 array (k=1)'
+            CALL prihre( ahm1(:,:,1), jpi, jpj, 1, jpi, 1, 1, jpj, 1, 1.e-3, numout )
+            WRITE(numout,*)
+            WRITE(numout,*) '         3D ahm2 array (k=1)'
+            CALL prihre( ahm2(:,:,1), jpi, jpj, 1, jpi, 1, 1, jpj, 1, 1.e-3, numout )
+         ENDIF
+
+      ENDIF
+      
 
       ! ahm3 and ahm4 at U- and V-points (used for bilaplacian operator
@@ -172,8 +175,8 @@
             WRITE(numout,*)
             WRITE(numout,*) 'inildf: ahm3 array at level 1'
-            CALL prihre(ahm3(:,:,1  ),jpi,jpj,1,jpi,1,1,jpj,1,1.e-3,numout)
+            CALL prihre(ahm3(:,:,1  ),jpi,jpj,1,jpi,1,1,jpj,1,1.e-12,numout)
             WRITE(numout,*)
             WRITE(numout,*) 'inildf: ahm4 array at level 1'
-            CALL prihre(ahm4(:,:,jpk),jpi,jpj,1,jpi,1,1,jpj,1,1.e-3,numout)
+            CALL prihre(ahm4(:,:,jpk),jpi,jpj,1,jpi,1,1,jpj,1,1.e-12,numout)
          ENDIF
       ENDIF
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 3938)
@@ -33,4 +33,6 @@
    USE wrk_nemo        ! work arrays
    USE timing          ! Timing
+   USE lib_fortran     ! to use key_nosignedzero
+ 
 
    IMPLICIT NONE
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90	(revision 3938)
@@ -9,4 +9,5 @@
    !!             -   ! 2010-11  (G. Madec) ice-ocean stress always computed at each ocean time-step
    !!            3.3  ! 2010-10  (J. Chanut, C. Bricaud)  add the surface pressure forcing
+   !!            4.0  ! 2012-05  (C. Rousset) add attenuation coef for use in ice model 
    !!----------------------------------------------------------------------
 
@@ -68,4 +69,6 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::  qsr_hc , qsr_hc_b   !: heat content trend due to qsr flux     [K.m/s] jpi,jpj,jpk
    !!
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   oatte, iatte      !: clem attenuation coef of the input solar flux [unitless]
+   !!
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   tprecip           !: total precipitation                          [Kg/m2/s]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   sprecip           !: solid precipitation                          [Kg/m2/s]
@@ -111,5 +114,6 @@
          !
       ALLOCATE( rnf  (jpi,jpj) , sbc_tsc  (jpi,jpj,jpts) , qsr_hc  (jpi,jpj,jpk) ,     &
-         &      rnf_b(jpi,jpj) , sbc_tsc_b(jpi,jpj,jpts) , qsr_hc_b(jpi,jpj,jpk) , STAT=ierr(3) )
+         &      rnf_b(jpi,jpj) , sbc_tsc_b(jpi,jpj,jpts) , qsr_hc_b(jpi,jpj,jpk) ,     &
+         &      iatte(jpi,jpj) , oatte    (jpi,jpj)                              , STAT=ierr(3) )
          !
       ALLOCATE( tprecip(jpi,jpj) , sprecip(jpi,jpj) , fr_i(jpi,jpj) ,     &
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 3938)
@@ -68,5 +68,6 @@
    REAL(wp), PARAMETER ::   Ls   =    2.839e6     ! latent heat of sublimation
    REAL(wp), PARAMETER ::   Stef =    5.67e-8     ! Stefan Boltzmann constant
-   REAL(wp), PARAMETER ::   Cice =    1.63e-3     ! transfer coefficient over ice
+   !iovi REAL(wp), PARAMETER ::   Cice =    1.63e-3     ! transfer coefficient over ice
+   REAL(wp), PARAMETER ::   Cice =    1.4e-3      ! transfer coefficient over ice
    REAL(wp), PARAMETER ::   albo =    0.066       ! ocean albedo assumed to be contant
 
@@ -75,4 +76,6 @@
    LOGICAL  ::   ln_taudif = .FALSE.   ! logical flag to use the "mean of stress module - module of mean stress" data
    REAL(wp) ::   rn_pfac   = 1.        ! multiplication factor for precipitation
+   REAL(wp) ::   rn_efac   = 1.        ! multiplication factor for evaporation (clem)
+   REAL(wp) ::   rn_vfac   = 1.        ! multiplication factor for ice/ocean velocity in the calculation of wind stress (clem)
 
    !! * Substitutions
@@ -128,5 +131,5 @@
       TYPE(FLD_N) ::   sn_qlw , sn_tair, sn_prec, sn_snow      !   "                                 "
       TYPE(FLD_N) ::   sn_tdif                                 !   "                                 "
-      NAMELIST/namsbc_core/ cn_dir , ln_2m  , ln_taudif, rn_pfac,           &
+      NAMELIST/namsbc_core/ cn_dir , ln_2m  , ln_taudif, rn_pfac, rn_efac, rn_vfac,  &
          &                  sn_wndi, sn_wndj, sn_humi  , sn_qsr ,           &
          &                  sn_qlw , sn_tair, sn_prec  , sn_snow, sn_tdif
@@ -266,6 +269,6 @@
       DO jj = 2, jpjm1
          DO ji = fs_2, fs_jpim1   ! vect. opt.
-            zwnd_i(ji,jj) = (  sf(jp_wndi)%fnow(ji,jj,1) - 0.5 * ( pu(ji-1,jj  ) + pu(ji,jj) )  )
-            zwnd_j(ji,jj) = (  sf(jp_wndj)%fnow(ji,jj,1) - 0.5 * ( pv(ji  ,jj-1) + pv(ji,jj) )  )
+            zwnd_i(ji,jj) = (  sf(jp_wndi)%fnow(ji,jj,1) - rn_vfac * 0.5 * ( pu(ji-1,jj  ) + pu(ji,jj) )  )
+            zwnd_j(ji,jj) = (  sf(jp_wndj)%fnow(ji,jj,1) - rn_vfac * 0.5 * ( pv(ji  ,jj-1) + pv(ji,jj) )  )
          END DO
       END DO
@@ -351,11 +354,11 @@
       IF( ln_2m ) THEN
          ! Values of temp. and hum. adjusted to 10m must be used instead of 2m values
-         zevap(:,:) = MAX( 0.e0, rhoa    *Ce(:,:)*( zqsatw(:,:) - zq_zu(:,:) ) * wndm(:,:) )   ! Evaporation
-         zqsb (:,:) =            rhoa*cpa*Ch(:,:)*( zst   (:,:) - zt_zu(:,:) ) * wndm(:,:)     ! Sensible Heat
+         zevap(:,:) = rn_efac * MAX( 0.e0, rhoa    *Ce(:,:)*( zqsatw(:,:) - zq_zu(:,:) ) * wndm(:,:) )   ! Evaporation
+         zqsb (:,:) =                      rhoa*cpa*Ch(:,:)*( zst   (:,:) - zt_zu(:,:) ) * wndm(:,:)     ! Sensible Heat
       ELSE
 !CDIR COLLAPSE
-         zevap(:,:) = MAX( 0.e0, rhoa    *Ce(:,:)*( zqsatw(:,:) - sf(jp_humi)%fnow(:,:,1) ) * wndm(:,:) )   ! Evaporation
-!CDIR COLLAPSE
-         zqsb (:,:) =            rhoa*cpa*Ch(:,:)*( zst   (:,:) - sf(jp_tair)%fnow(:,:,1) ) * wndm(:,:)     ! Sensible Heat
+         zevap(:,:) = rn_efac * MAX( 0.e0, rhoa    *Ce(:,:)*( zqsatw(:,:) - sf(jp_humi)%fnow(:,:,1) ) * wndm(:,:) )   ! Evaporation
+!CDIR COLLAPSE
+         zqsb (:,:) =                      rhoa*cpa*Ch(:,:)*( zst   (:,:) - sf(jp_tair)%fnow(:,:,1) ) * wndm(:,:)     ! Sensible Heat
       ENDIF
 !CDIR COLLAPSE
@@ -491,7 +494,7 @@
                ! ... scalar wind at I-point (fld being at T-point)
                zwndi_f = 0.25 * (  sf(jp_wndi)%fnow(ji-1,jj  ,1) + sf(jp_wndi)%fnow(ji  ,jj  ,1)   &
-                  &              + sf(jp_wndi)%fnow(ji-1,jj-1,1) + sf(jp_wndi)%fnow(ji  ,jj-1,1)  ) - pui(ji,jj)
+                  &              + sf(jp_wndi)%fnow(ji-1,jj-1,1) + sf(jp_wndi)%fnow(ji  ,jj-1,1)  ) - rn_vfac * pui(ji,jj)
                zwndj_f = 0.25 * (  sf(jp_wndj)%fnow(ji-1,jj  ,1) + sf(jp_wndj)%fnow(ji  ,jj  ,1)   &
-                  &              + sf(jp_wndj)%fnow(ji-1,jj-1,1) + sf(jp_wndj)%fnow(ji  ,jj-1,1)  ) - pvi(ji,jj)
+                  &              + sf(jp_wndj)%fnow(ji-1,jj-1,1) + sf(jp_wndj)%fnow(ji  ,jj-1,1)  ) - rn_vfac * pvi(ji,jj)
                zwnorm_f = zcoef_wnorm * SQRT( zwndi_f * zwndi_f + zwndj_f * zwndj_f )
                ! ... ice stress at I-point
@@ -499,8 +502,8 @@
                p_tauj(ji,jj) = zwnorm_f * zwndj_f
                ! ... scalar wind at T-point (fld being at T-point)
-               zwndi_t = sf(jp_wndi)%fnow(ji,jj,1) - 0.25 * (  pui(ji,jj+1) + pui(ji+1,jj+1)   &
-                  &                                          + pui(ji,jj  ) + pui(ji+1,jj  )  )
-               zwndj_t = sf(jp_wndj)%fnow(ji,jj,1) - 0.25 * (  pvi(ji,jj+1) + pvi(ji+1,jj+1)   &
-                  &                                          + pvi(ji,jj  ) + pvi(ji+1,jj  )  )
+               zwndi_t = sf(jp_wndi)%fnow(ji,jj,1) - rn_vfac * 0.25 * (  pui(ji,jj+1) + pui(ji+1,jj+1)   &
+                  &                                                    + pui(ji,jj  ) + pui(ji+1,jj  )  )
+               zwndj_t = sf(jp_wndj)%fnow(ji,jj,1) - rn_vfac * 0.25 * (  pvi(ji,jj+1) + pvi(ji+1,jj+1)   &
+                  &                                                    + pvi(ji,jj  ) + pvi(ji+1,jj  )  )
                z_wnds_t(ji,jj)  = SQRT( zwndi_t * zwndi_t + zwndj_t * zwndj_t ) * tmask(ji,jj,1)
             END DO
@@ -516,6 +519,6 @@
          DO jj = 2, jpj
             DO ji = fs_2, jpi   ! vect. opt.
-               zwndi_t = (  sf(jp_wndi)%fnow(ji,jj,1) - 0.5 * ( pui(ji-1,jj  ) + pui(ji,jj) )  )
-               zwndj_t = (  sf(jp_wndj)%fnow(ji,jj,1) - 0.5 * ( pvi(ji  ,jj-1) + pvi(ji,jj) )  )
+               zwndi_t = (  sf(jp_wndi)%fnow(ji,jj,1) - rn_vfac * 0.5 * ( pui(ji-1,jj  ) + pui(ji,jj) )  )
+               zwndj_t = (  sf(jp_wndj)%fnow(ji,jj,1) - rn_vfac * 0.5 * ( pvi(ji  ,jj-1) + pvi(ji,jj) )  )
                z_wnds_t(ji,jj)  = SQRT( zwndi_t * zwndi_t + zwndj_t * zwndj_t ) * tmask(ji,jj,1)
             END DO
@@ -555,5 +558,10 @@
                p_qsr(ji,jj,jl) = zztmp * ( 1. - palb(ji,jj,jl) ) * qsr(ji,jj)
                ! Long  Wave (lw)
-               z_qlw(ji,jj,jl) = 0.95 * (  sf(jp_qlw)%fnow(ji,jj,1) - Stef * pst(ji,jj,jl) * zst3  ) * tmask(ji,jj,1)
+               ! iovino
+               IF( ff(ji,jj) .GT. 0._wp ) THEN
+                  z_qlw(ji,jj,jl) = ( 0.95 * sf(jp_qlw)%fnow(ji,jj,1) - Stef * pst(ji,jj,jl) * zst3 ) * tmask(ji,jj,1) ! MV test 2 garde juste cette ligne ci
+               ELSE
+                  z_qlw(ji,jj,jl) = 0.95 * ( sf(jp_qlw)%fnow(ji,jj,1) - Stef * pst(ji,jj,jl) * zst3 ) * tmask(ji,jj,1) ! MV test 1 garde juste cette ligne ci
+               ENDIF
                ! lw sensitivity
                z_dqlw(ji,jj,jl) = zcoef_dqlw * zst3                                               
@@ -567,11 +575,12 @@
                z_qsb(ji,jj,jl) = rhoa * cpa * Cice * z_wnds_t(ji,jj) * ( pst(ji,jj,jl) - sf(jp_tair)%fnow(ji,jj,1) )
                ! Latent Heat
-               p_qla(ji,jj,jl) = MAX( 0.e0, rhoa * Ls  * Cice * z_wnds_t(ji,jj)   &                           
-                  &                    * (  11637800. * EXP( -5897.8 / pst(ji,jj,jl) ) / rhoa - sf(jp_humi)%fnow(ji,jj,1)  ) )
+               p_qla(ji,jj,jl) = rn_efac * MAX( 0.e0, rhoa * Ls  * Cice * z_wnds_t(ji,jj)   &                           
+                  &                         * (  11637800. * EXP( -5897.8 / pst(ji,jj,jl) ) / rhoa - sf(jp_humi)%fnow(ji,jj,1)  ) )
                ! Latent heat sensitivity for ice (Dqla/Dt)
-               p_dqla(ji,jj,jl) = zcoef_dqla * z_wnds_t(ji,jj) / ( zst2 ) * EXP( -5897.8 / pst(ji,jj,jl) )
+               p_dqla(ji,jj,jl) = rn_efac * zcoef_dqla * z_wnds_t(ji,jj) / ( zst2 ) * EXP( -5897.8 / pst(ji,jj,jl) )
                ! Sensible heat sensitivity (Dqsb_ice/Dtn_ice)
                z_dqsb(ji,jj,jl) = zcoef_dqsb * z_wnds_t(ji,jj)
-
+               !
+               !
                ! ----------------------------!
                !     III    Total FLUXES     !
@@ -601,5 +610,6 @@
 !CDIR COLLAPSE
       p_spr(:,:) = sf(jp_snow)%fnow(:,:,1) * rn_pfac      ! solid precipitation [kg/m2/s]
-      CALL iom_put( 'snowpre', p_spr )                  ! Snow precipitation 
+      CALL iom_put( 'snowpre', p_spr * 86400 )                  ! Snow precipitation 
+      CALL iom_put( 'precip', p_tpr * 86400 )                   ! Total precipitation 
       !
       IF(ln_ctl) THEN
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90	(revision 3938)
@@ -97,5 +97,6 @@
             z_fwf = glob_sum( e1e2t(:,:) * ( emp(:,:) - rnf(:,:) ) ) / area   ! sum over the global domain
             emp (:,:) = emp (:,:) - z_fwf 
-            emps(:,:) = emps(:,:) - z_fwf 
+            erp (:,:) = erp (:,:) - z_fwf 
+!SF bad            emps(:,:) = emps(:,:) - z_fwf 
          ENDIF
          !
@@ -127,5 +128,6 @@
          IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN      ! correct the freshwater fluxes
             emp (:,:) = emp (:,:) + fwfold
-            emps(:,:) = emps(:,:) + fwfold
+            erp (:,:) = erp (:,:) + fwfold
+!SF bad            emps(:,:) = emps(:,:) + fwfold
          ENDIF
          !
@@ -169,5 +171,5 @@
             !
             emp (:,:) = emp (:,:) + zerp_cor(:,:)
-            emps(:,:) = emps(:,:) + zerp_cor(:,:)
+!SF bad            emps(:,:) = emps(:,:) + zerp_cor(:,:)
             erp (:,:) = erp (:,:) + zerp_cor(:,:)
             !
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 3938)
@@ -11,4 +11,5 @@
    !!            3.3  ! 2010-11  (G. Madec) ice-ocean stress always computed at each ocean time-step
    !!            4.0  ! 2011-01  (A Porter)  dynamical allocation
+   !!             -   ! 2012-10  (C. Rousset)  add lim_diahsb
    !!----------------------------------------------------------------------
 #if defined key_lim3
@@ -42,7 +43,10 @@
    USE limsbc          ! sea surface boundary condition
    USE limdia          ! Ice diagnostics
+   USE limdiahsb       ! Ice budget diagnostics
    USE limwri          ! Ice outputs
    USE limrst          ! Ice restarts
-   USE limupdate       ! update of global variables
+!clem@order   USE limupdate       ! update of global variables
+   USE limupdate1       ! update of global variables
+   USE limupdate2       ! update of global variables
    USE limvar          ! Ice variables switch
 
@@ -51,7 +55,12 @@
    USE lib_mpp         ! MPP library
    USE wrk_nemo        ! work arrays
+   USE timing          ! Timing
    USE iom             ! I/O manager library
    USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
+
+#if defined key_bdy 
+   USE bdyice_lim       ! unstructured open boundary data  (bdy_ice_lim routine)
+#endif
 
    IMPLICIT NONE
@@ -98,4 +107,6 @@
       !!----------------------------------------------------------------------
 
+      IF( nn_timing == 1 )  CALL timing_start('sbc_ice_lim')
+
       CALL wrk_alloc( jpi,jpj,jpl, zalb_ice_os, zalb_ice_cs )
 
@@ -108,5 +119,7 @@
          !
          IF( ln_nicep ) THEN      ! control print at a given point
-            jiindx = 44   ;   jjindx = 140
+            !jiindx = 3   ;   jjindx = 51
+            !jiindx = 34   ;   jjindx = 45
+            jiindx = 117   ;   jjindx = 116
             WRITE(numout,*) ' The debugging point is : jiindx : ',jiindx, ' jjindx : ',jjindx
          ENDIF
@@ -153,4 +166,7 @@
          END SELECT
 
+         CALL iom_put( 'utau_ice', utau_ice )     ! Wind stress over ice along i-axis at I-point
+         CALL iom_put( 'vtau_ice', vtau_ice )     ! Wind stress over ice along j-axis at I-point
+
          !                                           !----------------------!
          !                                           ! LIM-3  time-stepping !
@@ -178,18 +194,38 @@
          d_oa_i_thd (:,:,:)   = 0.e0   ;   d_oa_i_trp (:,:,:)   = 0.e0
          !
-         fseqv    (:,:) = 0.e0
-         fsbri    (:,:) = 0.e0     ;   fsalt_res(:,:) = 0.e0
+         !clem fseqv    (:,:) = 0.e0
+         !clem fsbri    (:,:) = 0.e0
+         fsalt_res(:,:) = 0.e0
          fsalt_rpo(:,:) = 0.e0
-         fhmec    (:,:) = 0.e0     ;   fhbri    (:,:) = 0.e0
-         fmmec    (:,:) = 0.e0     ;   fheat_res(:,:) = 0.e0
-         fheat_rpo(:,:) = 0.e0     ;   focea2D  (:,:) = 0.e0
+         fhmec    (:,:) = 0.e0
+         !clem fhbri    (:,:) = 0.e0
+         fmmec    (:,:) = 0.e0
+         fheat_res(:,:) = 0.e0
+         fheat_rpo(:,:) = 0.e0
+         focea2D  (:,:) = 0.e0
          fsup2D   (:,:) = 0.e0
-         ! 
+
+         ! clem: moved from limthd.F90 
+         rdvosif(:,:) = 0.e0   ! variation of ice volume at surface
+         rdvobif(:,:) = 0.e0   ! variation of ice volume at bottom
+         fdvolif(:,:) = 0.e0   ! total variation of ice volume
+         rdvonif(:,:) = 0.e0   ! lateral variation of ice volume
+         fstric (:,:) = 0.e0   ! part of solar radiation transmitted through the ice
+         ffltbif(:,:) = 0.e0   ! linked with fstric
+         qfvbq  (:,:) = 0.e0   ! linked with fstric
+         rdmsnif(:,:) = 0.e0   ! variation of snow mass per unit area
+         rdmicif(:,:) = 0.e0   ! variation of ice mass per unit area
+         hicifp (:,:) = 0.e0   ! daily thermodynamic ice production. 
+         fsbri  (:,:) = 0.e0   ! brine flux contribution to salt flux to the ocean
+         fhbri  (:,:) = 0.e0   ! brine flux contribution to heat flux to the ocean
+         fseqv  (:,:) = 0.e0   ! equivalent salt flux to the ocean due to ice/growth decay
+         !
          diag_sni_gr(:,:) = 0.e0   ;   diag_lat_gr(:,:) = 0.e0
          diag_bot_gr(:,:) = 0.e0   ;   diag_dyn_gr(:,:) = 0.e0
          diag_bot_me(:,:) = 0.e0   ;   diag_sur_me(:,:) = 0.e0
+         diag_res_pr(:,:) = 0.e0   ;   diag_trp_vi(:,:) = 0.e0
          ! dynamical invariants
          delta_i(:,:) = 0.e0       ;   divu_i(:,:) = 0.e0       ;   shear_i(:,:) = 0.e0
-
+         !
                           CALL lim_rst_opn( kt )     ! Open Ice restart file
          !
@@ -200,9 +236,23 @@
                           CALL lim_dyn( kt )              ! Ice dynamics    ( rheology/dynamics )
                           CALL lim_trp( kt )              ! Ice transport   ( Advection/diffusion )
-                          CALL lim_var_agg(1)             ! aggregate categories, requested
+                          !clem(done in trp wo ato_i) CALL lim_var_agg(1)             ! aggregate categories, requested
                           CALL lim_var_glo2eqv            ! equivalent variables, requested for rafting
          IF( ln_nicep )   CALL lim_prt_state( jiindx, jjindx,-1, ' - ice dyn & trp - ' )   ! control print
                           CALL lim_itd_me                 ! Mechanical redistribution ! (ridging/rafting)
+                          CALL lim_var_agg( 1 ) ! clem@order
+                          CALL lim_update1  ! clem@order
          ENDIF
+!                          !- Change old values for new values
+!clem@order
+                          old_u_ice(:,:)   = u_ice (:,:)
+                          old_v_ice(:,:)   = v_ice (:,:)
+                          old_a_i(:,:,:)   = a_i (:,:,:)
+                          old_v_s(:,:,:)   = v_s (:,:,:)
+                          old_v_i(:,:,:)   = v_i (:,:,:)
+                          old_e_s(:,:,:,:) = e_s (:,:,:,:)
+                          old_e_i(:,:,:,:) = e_i (:,:,:,:)
+                          old_oa_i(:,:,:)  = oa_i(:,:,:)
+                          old_smv_i(:,:,:) = smv_i (:,:,:)
+!clem@order
          !                                           ! Ice thermodynamics 
                           CALL lim_var_glo2eqv            ! equivalent variables
@@ -218,5 +268,10 @@
          !                                           ! Global variables update
                           CALL lim_var_agg( 1 )           ! requested by limupdate
-                          CALL lim_update                 ! Global variables update
+                          !clem@order CALL lim_update                 ! Global variables update
+                          CALL lim_update2  ! clem@order
+!
+#if defined key_bdy
+                          CALL bdy_ice_lim( kt )          ! clem modif: bdy ice
+#endif
                           CALL lim_var_glo2eqv            ! equivalent variables (outputs)
                           CALL lim_var_agg(2)             ! aggregate ice thickness categories
@@ -230,5 +285,7 @@
          IF( ( MOD( kt+nn_fsbc-1, ninfo ) == 0 .OR. ntmoy == 1 ) .AND. .NOT. lk_mpp )   &
             &             CALL lim_dia 
+        IF (ln_limdiahsb) CALL lim_diahsb
                           CALL lim_wri( 1  )              ! Ice outputs 
+         IF( kt == nit000 )   CALL iom_close( numrir )  ! clem: close input ice restart file
          IF( lrst_ice )   CALL lim_rst_write( kt )        ! Ice restart file 
                           CALL lim_var_glo2eqv            ! ???
@@ -236,5 +293,5 @@
          IF( ln_nicep )   CALL lim_ctl               ! alerts in case of model crash
          !
-      ENDIF                                    ! End sea-ice time step only
+     ENDIF                                    ! End sea-ice time step only
 
       !                                        !--------------------------!
@@ -249,4 +306,6 @@
       !
       CALL wrk_dealloc( jpi,jpj,jpl, zalb_ice_os, zalb_ice_cs )
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('sbc_ice_lim')
       !
    END SUBROUTINE sbc_ice_lim
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 3938)
@@ -48,4 +48,8 @@
    USE in_out_manager   ! I/O manager
    USE prtctl           ! Print control
+
+#if defined key_bdy 
+   USE bdyice_lim       ! unstructured open boundary data  (bdy_ice_lim routine)
+#endif
 
    IMPLICIT NONE
@@ -191,4 +195,7 @@
            IF( ln_limdmp ) CALL lim_dmp_2      ( kt )      ! Ice damping 
          END IF
+!#if defined key_bdy
+!                           CALL bdy_ice_lim    ( kt )      ! clem modif
+!#endif
 #if defined key_coupled
          !                                             ! Ice surface fluxes in coupled mode 
@@ -202,4 +209,7 @@
 #endif
                            CALL lim_thd_2      ( kt )      ! Ice thermodynamics 
+#if defined key_bdy
+                           CALL bdy_ice_lim    ( kt )      ! clem modif
+#endif
                            CALL lim_sbc_flx_2  ( kt )      ! update surface ocean mass, heat & salt fluxes 
 
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 3938)
@@ -12,4 +12,5 @@
    !!             -   ! 2010-10  (J. Chanut, C. Bricaud, G. Madec)  add the surface pressure forcing
    !!            3.4  ! 2011-11  (C. Harris) CICE added as an option
+   !!             -   ! 2012-01  (C. Rousset) add ice boundary conditions for LIM3
    !!----------------------------------------------------------------------
 
@@ -42,5 +43,5 @@
    USE closea           ! closed sea
    USE bdy_par          ! for lk_bdy
-   USE bdyice_lim2      ! unstructured open boundary data  (bdy_ice_lim_2 routine)
+   USE bdyice_lim       ! unstructured open boundary data  (bdy_ice_lim routine)
 
    USE prtctl           ! Print control                    (prt_ctl routine)
@@ -96,9 +97,9 @@
 
       !                          ! overwrite namelist parameter using CPP key information
-      IF( Agrif_Root() ) THEN                ! AGRIF zoom
-        IF( lk_lim2 )   nn_ice      = 2
-        IF( lk_lim3 )   nn_ice      = 3
-        IF( lk_cice )   nn_ice      = 4
-      ENDIF
+      !IF( Agrif_Root() ) THEN                ! AGRIF zoom
+      !  IF( lk_lim2 )   nn_ice      = 2
+      !  IF( lk_lim3 )   nn_ice      = 3
+      !  IF( lk_cice )   nn_ice      = 4
+      !ENDIF
       IF( cp_cfg == 'gyre' ) THEN            ! GYRE configuration
           ln_ana      = .TRUE.   
@@ -276,7 +277,8 @@
          !                                                      
       CASE(  2 )   ;       CALL sbc_ice_lim_2( kt, nsbc )            ! LIM-2 ice model
-         IF( lk_bdy )      CALL bdy_ice_lim_2( kt )                  ! BDY boundary condition
+         !IF( lk_bdy )      CALL bdy_ice_lim( kt )                   ! clem modif BDY boundary condition
          !                                                     
       CASE(  3 )   ;       CALL sbc_ice_lim  ( kt, nsbc )            ! LIM-3 ice model
+         !IF( lk_bdy )      CALL bdy_ice_lim( kt )                   ! clem modif BDY boundary condition
          !
       CASE(  4 )   ;       CALL sbc_ice_cice ( kt, nsbc )            ! CICE ice model
@@ -337,5 +339,6 @@
       IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN
          CALL iom_put( "empmr" , emp  - rnf )                   ! upward water flux
-         CALL iom_put( "empsmr", emps - rnf )                   ! c/d water flux
+!!sf     CALL iom_put( "empsmr", emps - rnf )                   ! c/d water flux
+         CALL iom_put( "empsmr", emps       )                   ! modif lim3 : salt flux
          CALL iom_put( "qt"    , qns  + qsr )                   ! total heat flux 
          CALL iom_put( "qns"   , qns        )                   ! solar heat flux
